///////////////////////////////////////////////////////////////////////////
/// emu_core.h
///////////////////////////////////////////////////////////////////////////
#ifndef _EMU_CORE_H
#define _EMU_CORE_H
///////////////////////////////////////////////////////////////////////////
#include "emu_config.h"
#include "emu_state.h"
#include "emu_cheat.h"
#include "psp_pad.h"
///////////////////////////////////////////////////////////////////////////
enum{ EMU_MD, EMU_PCE, MAX_EMU } ;
#define MAX_EMU_CORE_BUFF  (12 * 1024 * 1024)
///////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C"
{
#endif
///////////////////////////////////////////////////////////////////////////
extern unsigned char    sEmuCoreBuff[ MAX_EMU_CORE_BUFF ] ;
extern int              emu_mode                          ;
extern EMU_CONFIG       emu_config[MAX_EMU]               ;
extern EMU_STATE        emu_state                         ;
extern EMU_CHEAT        emu_cheat                         ;
///////////////////////////////////////////////////////////////////////////

int EmuCore_IsSaveSRAM () ;
int EmuCore_SaveSRAM   ( const char* path ) ;

//////////////////////////////////////////////////////////////////////
/// MD core
//////////////////////////////////////////////////////////////////////
extern void md_init_memory( unsigned char* pCoreBuff, unsigned long nBuffSize ) ;
extern void md_init() ;
extern void md_setconfig( EMU_CONFIG* emc ) ;
extern int  md_load_rom( const char* path ) ;
extern int  md_is_save_sram () ;
extern int  md_load_sram( const char* path ) ;
extern int  md_save_sram( const char* path ) ;
extern void md_setframe( unsigned char* p, int width ) ;
extern void md_sound_update( short* p, short len ) ;
extern void md_setpaddata( PSP_PAD_DATA* pPad, EMU_CONFIG* emc ) ;
extern int  md_get_state( EMU_STATE_SLOT* ess ) ;
extern int  md_set_state( EMU_STATE_SLOT* ess ) ;
extern void md_cheat_exec( unsigned long addr, unsigned short val );
extern int  md_run() ;
extern int  md_run_skip() ;
//////////////////////////////////////////////////////////////////////
/// PCE core
//////////////////////////////////////////////////////////////////////
extern void pce_init_memory( unsigned char* pCoreBuff, unsigned long nBuffSize ) ;
extern void pce_init() ;
extern void pce_setconfig( EMU_CONFIG* emc ) ;
extern int  pce_load_rom( const char* path ) ;
extern void pce_setframe( unsigned char* p, int width ) ;
extern int  pce_sound_update( short* p, short len ) ;
extern void pce_setpaddata ( unsigned long buttons ) ;
extern int  pce_run() ;
extern int  pce_run_skip() ;

//////////////////////////////////////////////////////////////////////
/// GB core
//////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
}
#endif
///////////////////////////////////////////////////////////////////////////
#endif // _EMU_CORE_H
///////////////////////////////////////////////////////////////////////////
